/* gEDA - GNU Electronic Design Automation
 * gschem - GNU Schematic Capture
 * Copyright (C) 1998 Ales V. Hvezda
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <config.h>
#include <stdio.h>
#include <strings.h>
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk/gdkx.h>

#include <guile/gh.h>
#include "defines.h"
#include "globals.h"
#include "struct.h"

#include "prototype.h"
#include "libgeda/prototype.h"

void
i_callback_file_quit (GtkWidget *widget, gpointer data)
{
	exit(0);
}

void
i_callback_launch (GtkWidget *widget, gpointer data)
{
	TOOL *t_current;

	t_current = (TOOL *) data;

	exit_if_null(t_current);

	printf("%s button pressed\n", t_current->tool);
	printf("no, this tool doesn't run the programs yet...\n");
}

