/* gEDA - GNU Electronic Design Automation
 * gpcb - GNU Printed Circuit Board
 * Copyright (C) 1998 Ales V. Hvezda
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef FILE_H
#define FILE_H

#include <config.h>
#include <stdio.h>
#include <math.h>

#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk/gdkx.h>

#include <guile/gh.h>

#include "struct.h"
#include "pcb_struct.h"
#include "defines.h"
#include "globals.h"
#include "s_passing.h"
#include "o_types.h"

#include "colors.h"

#include "footprint.h"
#include "list.h"

#include "prototype.h"
#include "../libgeda/prototype.h"

FOOTPRINT_T *
readFootprint(PAGE_T *page, char *filename);

void
writeComponents(FILE *fp, PAGE_T *page);

void
readComponent(char *str, PAGE_T *page);

void
writeNets(FILE *fp, PAGE_T *page);

PAD_T *
findPad(FOOTPRINT_T *foot, PAD_NAME padId);

COMPONENT_T *
findComponent(PAGE_T *page, COMP_REF id);

void
readNet(char *str, PAGE_T *page);

void
writeTracks(FILE *fp, PAGE_T *page);

void
readTrack(char *str, PAGE_T *page);

void
file_open(PAGE_T *page, char *filename);

void
file_saveas(PAGE_T *page, char *filename);

#endif
