/* gEDA - GNU Electronic Design Automation
 * gschem/gpcb - GNU Schematic Capture and Printed Circuit Board
 * Copyright (C) 1998 Ales V. Hvezda
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <config.h>
#include <stdio.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk/gdkx.h>

#include <guile/gh.h>


#include "struct.h"
#include "defines.h"
#include "globals.h"
#include "s_passing.h"
#include "o_types.h"
#include "x_states.h"
#include "colors.h"

#include "prototype.h"
#include "../libgeda/prototype.h"

static int default_graphic_color=GREEN;
static int default_text_color=GREEN;
static int default_text_size=8;
static int default_text_caps=LOWER;
static int default_attribute_color=YELLOW;
static int default_detachattr_color=RED;
static int default_net_color=BLUE;
static int default_net_endpoint_color=RED;
static int default_override_net_color=-1;
static int default_override_pin_color=-1;
static int default_net_endpoint_mode=FILLEDBOX;
static int default_net_midpoint_mode=FILLED;
static int default_pin_color=WHITE;
static int default_pin_style=THICK;
static int default_net_style=THICK;
static int default_grid_color=GREY;
static int default_background_color=BLACK;
static int default_select_color=GREY90;
static int default_bb_color=GREY90;
static int default_actionfeedback_mode=OUTLINE; 
static int default_object_clipping=TRUE; 
static int default_do_logging=TRUE; 
static int default_logging_dest=LOG_WINDOW; 
static int default_embed_complex=FALSE; 
static int default_text_output=VECTOR_FONTS; 
static int default_snap_size=100; 

/* hack change to i_callbacks once you figure out how to keymap */
/*#include "i_funcs.h"*/

void
i_vars_setdefault(TOPLEVEL *w_current)
{

/* put this back when you get keymaps working again */
/* 	int i;*/
	
	do_logging = default_do_logging;
	logging_dest = default_logging_dest;

	w_current->graphic_color = default_graphic_color;
	w_current->text_color = default_text_color;
	w_current->text_size = default_text_size;
	w_current->text_caps = default_text_caps; 

	w_current->attribute_color = default_attribute_color;
	w_current->detachedattr_color = default_detachattr_color;

	w_current->grid_color = default_grid_color;
	w_current->background_color = default_background_color;
	w_current->select_color = default_select_color;

	w_current->bb_color = default_bb_color;

	w_current->net_color = default_net_color;
	w_current->net_style = default_net_style;
	w_current->net_endpoint_color = default_net_endpoint_color;
	w_current->net_endpoint_mode = default_net_endpoint_mode;
	w_current->net_midpoint_mode = default_net_midpoint_mode;
	w_current->override_net_color = default_override_net_color;

	w_current->pin_color = default_pin_color;
	w_current->pin_style = default_pin_style;
	w_current->override_pin_color = default_override_pin_color;

	w_current->actionfeedback_mode = default_actionfeedback_mode;

	w_current->object_clipping = default_object_clipping;
	w_current->embed_complex = default_embed_complex;
	w_current->text_output = default_text_output;
	w_current->snap_size = default_snap_size;

	w_current->print_output_type = LIMITS;

	w_current->untitled_name = malloc(sizeof(char)*(strlen("untitled")+1));
	strcpy(w_current->untitled_name, "untitled");

	w_current->series_name = malloc(sizeof(char)*(strlen("untitled")+1));
	strcpy(w_current->series_name, "untitled");
}
