/* gEDA - GNU Electronic Design Automation
 * gpcb - GNU Printed Circuit Board
 * Copyright (C) 1998 Ales V. Hvezda
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <config.h>
#include <math.h>
#include <stdio.h>

#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk/gdkx.h>

#include <guile/gh.h>

#include "struct.h"
#include "defines.h"
#include "globals.h"
#include "s_passing.h"
#include "o_types.h"

#include "colors.h"

#include "pcb_struct.h"
#include "a_memory.h"
#include "defaults.h"
#include "pad.h"

#include "prototype.h"
#include "../libgeda/prototype.h"

void
o_pad_draw(TOPLEVEL *w_current, PAD_T *pad, int x, int y, drawing_type modifier)
{
	int s_x, s_y, s_radius;  /* Screen coordinates */
	
	WORLDtoSCREEN(w_current, x+(pad->x), y+(pad->y), &s_x, &s_y);
	s_radius = scaleRadius(w_current, pad->size);

	if (modifier == DRAW_XOR) {
		gdk_gc_set_foreground(w_current->outline_xor_gc, selectedColor(LAYER_ALL));
		gdk_draw_arc(w_current->window, w_current->outline_xor_gc, TRUE, s_x - s_radius, s_y - s_radius,
		2 * s_radius, 2 * s_radius, 0, FULL_CIRCLE);
	}
	else {
		if (modifier == DRAW_CLEAR) {
       	         gdk_gc_set_foreground(w_current->gc,
       	                 backgroundColor(w_current));
		}
	       	 else if (modifier == DRAW_SELECTED) {
       		         gdk_gc_set_foreground(w_current->gc, 
       		                 selectedColor(LAYER_ALL));
       		 }
       		 else {
       		         gdk_gc_set_foreground(w_current->gc, 
       		                 layerToColor(LAYER_ALL));
       		 }
       		 gdk_draw_arc(w_current->window, w_current->gc, TRUE,
       		                                s_x - s_radius, s_y - s_radius,
       		                                2 * s_radius, 2 * s_radius, 0, FULL_CIRCLE);
       		 gdk_draw_arc(w_current->backingstore, w_current->gc, TRUE,
							s_x - s_radius, s_y - s_radius,
       		                                2 * s_radius, 2 * s_radius, 0, FULL_CIRCLE);
	}
}
