/* a_memory.c */
void out_of_memory(void);
PAGE_T *new_page(void);
SELECTION_T *new_selection(void);
COMPONENT_T *new_component(void);
FOOTPRINT_T *new_footprint(void);
TRACK_T *new_track(void);
TRACK_SEG_T *new_track_seg(void);
NET_T *new_net(void);
VIA_T *new_via(void);
PAD_T *new_pad(void);
/* a_pan.c */
void a_pan(TOPLEVEL *w_current, int x, int y);
/* a_zoom.c */
void a_zoom(TOPLEVEL *w_current, int dir);
void get_page_bounds(TOPLEVEL *w_current, int *left, int *right, int *top, int *bottom);
void a_zoom_limits(TOPLEVEL *w_current, OBJECT *o_current);
void a_zoom_box(TOPLEVEL *w_current);
void a_zoom_box_start(TOPLEVEL *w_current, int x, int y);
void a_zoom_box_end(TOPLEVEL *w_current, int x, int y);
void a_zoom_box_rubberband(TOPLEVEL *w_current, int x, int y);
/* component.c */
void updateCompBB(COMPONENT_T *comp);
void component_rubberband(TOPLEVEL *w_current, int mouse_x, int mouse_y);
void printComponent(COMPONENT_T *comp);
/* defaults.c */
GdkColor *backgroundColor(TOPLEVEL *w_current);
GdkColor *netColor(TOPLEVEL *w_current);
GdkColor *selectedColor(layer_type layer);
char *newID(char *str);
int scaleRadius(TOPLEVEL *w_current, int radius);
GdkColor *layerToColor(layer_type layer);
/* file.c */
FOOTPRINT_T *readFootprint(PAGE_T *page, char *filename);
void writeComponents(FILE *fp, PAGE_T *page);
void readComponent(char *str, PAGE_T *page);
void writeNets(FILE *fp, PAGE_T *page);
PAD_T *findPad(FOOTPRINT_T *foot, PAD_NAME padId);
COMPONENT_T *findComponent(PAGE_T *page, COMP_REF id);
void readNet(char *str, PAGE_T *page);
void writeTracks(FILE *fp, PAGE_T *page);
void readTrack(char *str, PAGE_T *page);
void file_open(PAGE_T *page, char *filename);
void file_saveas(PAGE_T *page, char *filename);
/* footprint.c */
void o_footprint_move(TOPLEVEL *w_current);
void o_footprint_draw(TOPLEVEL *w_current, FOOTPRINT_T *foot, int x, int y, drawing_type modifier);
void printFootprint(FOOTPRINT_T *foot);
void printPage(TOPLEVEL *w_current);
/* g_key.c */
void set_window_current_key(TOPLEVEL *w_current);
void g_key_execute(int state, int keyval);
SCM g_key_file_new(void);
SCM g_key_file_new_window(void);
SCM g_key_file_open(void);
SCM g_key_file_save(void);
SCM g_key_file_saveas(void);
SCM g_key_file_print(void);
SCM g_key_file_close_window(void);
SCM g_key_file_quit(void);
SCM g_key_edit_select(void);
SCM g_key_edit_copy(void);
SCM g_key_edit_copy_hotkey(void);
SCM g_key_edit_move(void);
SCM g_key_edit_move_hotkey(void);
SCM g_key_edit_delete(void);
SCM g_key_edit_rotate_90(void);
SCM g_key_edit_rotate_90_hotkey(void);
SCM g_key_edit_mirror(void);
SCM g_key_edit_mirror_hotkey(void);
SCM g_key_edit_slot(void);
SCM g_key_edit_edit(void);
SCM g_key_edit_lock(void);
SCM g_key_edit_unlock(void);
SCM g_key_edit_translate(void);
SCM g_key_edit_embed(void);
SCM g_key_edit_unembed(void);
SCM g_key_view_redraw(void);
SCM g_key_view_zoom_full(void);
SCM g_key_view_zoom_limits(void);
SCM g_key_view_zoom_in(void);
SCM g_key_view_zoom_out(void);
SCM g_key_view_zoom_box(void);
SCM g_key_view_zoom_box_hotkey(void);
SCM g_key_view_pan(void);
SCM g_key_view_pan_hotkey(void);
SCM g_key_view_updatenets(void);
SCM g_key_page_manager(void);
SCM g_key_page_next(void);
SCM g_key_page_prev(void);
SCM g_key_page_new(void);
SCM g_key_page_close(void);
SCM g_key_page_discard(void);
SCM g_key_page_print(void);
SCM g_key_add_component(void);
SCM g_key_add_attribute(void);
SCM g_key_add_net(void);
SCM g_key_add_net_hotkey(void);
SCM g_key_add_text(void);
SCM g_key_add_line(void);
SCM g_key_add_line_hotkey(void);
SCM g_key_add_box(void);
SCM g_key_add_box_hotkey(void);
SCM g_key_add_circle(void);
SCM g_key_add_circle_hotkey(void);
SCM g_key_add_arc(void);
SCM g_key_add_arc_hotkey(void);
SCM g_key_add_pin(void);
SCM g_key_add_pin_hotkey(void);
SCM g_key_hierarchy_open_symbol(void);
SCM g_key_attributes_attach(void);
SCM g_key_attributes_detach(void);
SCM g_key_attributes_show_name(void);
SCM g_key_attributes_show_value(void);
SCM g_key_attributes_show_both(void);
SCM g_key_attributes_visibility_toggle(void);
SCM g_key_script_console(void);
SCM g_key_options_text_size(void);
SCM g_key_options_afeedback(void);
SCM g_key_options_grid(void);
SCM g_key_options_snap(void);
SCM g_key_options_snap_size(void);
SCM g_key_options_show_log_window(void);
SCM g_key_misc(void);
SCM g_key_cancel(void);
/* g_rc.c */
void set_static_window_current(TOPLEVEL *w_current);
void g_rc_parse(TOPLEVEL *w_current);
SCM g_rc_gpcb_version(SCM version);
SCM g_rc_override_net_color(SCM color);
SCM g_rc_override_pin_color(SCM color);
SCM g_rc_attribute_color(SCM color);
SCM g_rc_detachedattr_color(SCM color);
SCM g_rc_text_color(SCM color);
SCM g_rc_net_color(SCM color);
SCM g_rc_graphic_color(SCM color);
SCM g_rc_grid_color(SCM color);
SCM g_rc_background_color(SCM color);
SCM g_rc_select_color(SCM color);
SCM g_rc_boundingbox_color(SCM color);
SCM g_rc_net_endpoint_color(SCM color);
SCM g_rc_net_endpoint_mode(SCM mode);
SCM g_rc_net_midpoint_mode(SCM mode);
SCM g_rc_net_style(SCM mode);
SCM g_rc_pin_style(SCM mode);
SCM g_rc_action_feedback_mode(SCM mode);
SCM g_rc_scrollbar_update(SCM mode);
SCM g_rc_object_clipping(SCM mode);
SCM g_rc_logging(SCM mode);
SCM g_rc_embed_components(SCM mode);
SCM g_rc_text_size(SCM size);
SCM g_rc_text_caps_style(SCM mode);
SCM g_rc_snap_size(SCM size);
SCM g_rc_logging_destination(SCM mode);
SCM g_rc_default_series_name(SCM name);
SCM g_rc_untitled_name(SCM name);
SCM g_rc_component_library(SCM path);
SCM g_rc_source_library(SCM path);
SCM g_rc_attribute_name(SCM path);
SCM g_rc_scheme_directory(SCM path);
SCM g_rc_font_directory(SCM path);
SCM g_rc_world_size(SCM width, SCM height, SCM border);
SCM g_rc_paper_size(SCM width, SCM height);
SCM g_rc_paper_sizes(SCM papername, SCM scm_width, SCM scm_height);
SCM g_rc_text_output(SCM mode);
/* g_register.c */
void g_register_funcs(void);
/* globals.c */
/* gpcb.c */
void gschem_quit(void);
void main_prog(int argc, char *argv[]);
int main(int argc, char *argv[]);
/* i_basic.c */
void i_update_status(TOPLEVEL *w_current, char *string);
void i_update_status2(TOPLEVEL *w_current, char *string);
void i_update_left_button(char *string);
void i_update_middle_button(TOPLEVEL *w_current, void *func_ptr, char *string);
void i_update_right_button(char *string);
void i_set_filename(TOPLEVEL *w_current, char *string);
/* i_callbacks.c */
void i_callback_file_new(GtkWidget *widget, gpointer data);
void i_callback_file_new_window(GtkWidget *widget, gpointer data);
void i_callback_file_open(GtkWidget *widget, gpointer data);
void i_callback_file_save(GtkWidget *widget, gpointer data);
void i_callback_file_saveas(GtkWidget *widget, gpointer data);
void i_callback_file_print(GtkWidget *widget, gpointer data);
void i_callback_file_close(GtkWidget *widget, gpointer data);
int i_callback_close(GtkWidget *widget, gpointer data);
void i_callback_file_quit(GtkWidget *widget, gpointer data);
void i_callback_edit_select(GtkWidget *widget, gpointer data);
void i_callback_edit_copy(GtkWidget *widget, gpointer data);
void i_callback_edit_copy_hotkey(GtkWidget *widget, gpointer data);
void i_callback_edit_move(GtkWidget *widget, gpointer data);
void i_callback_edit_move_hotkey(GtkWidget *widget, gpointer data);
void i_callback_edit_delete(GtkWidget *widget, gpointer data);
void i_callback_edit_edit(GtkWidget *widget, gpointer data);
void i_callback_edit_slot(GtkWidget *widget, gpointer data);
void i_callback_edit_rotate_90(GtkWidget *widget, gpointer data);
void i_callback_edit_rotate_90_hotkey(GtkWidget *widget, gpointer data);
void i_callback_edit_mirror(GtkWidget *widget, gpointer data);
void i_callback_edit_mirror_hotkey(GtkWidget *widget, gpointer data);
void i_callback_edit_lock(GtkWidget *widget, gpointer data);
void i_callback_edit_unlock(GtkWidget *widget, gpointer data);
void i_callback_edit_translate(GtkWidget *widget, gpointer data);
void i_callback_edit_embed(GtkWidget *widget, gpointer data);
void i_callback_edit_unembed(GtkWidget *widget, gpointer data);
void i_callback_view_redraw(GtkWidget *widget, gpointer data);
void i_callback_view_zoom_full(GtkWidget *widget, gpointer data);
void i_callback_view_zoom_limits(GtkWidget *widget, gpointer data);
void i_callback_view_zoom_box(GtkWidget *widget, gpointer data);
void i_callback_view_zoom_box_hotkey(GtkWidget *widget, gpointer data);
void i_callback_view_zoom_in(GtkWidget *widget, gpointer data);
void i_callback_view_zoom_out(GtkWidget *widget, gpointer data);
void i_callback_view_pan(GtkWidget *widget, gpointer data);
void i_callback_view_pan_hotkey(GtkWidget *widget, gpointer data);
void i_callback_view_updatenets(GtkWidget *widget, gpointer data);
void i_callback_page_manager(GtkWidget *widget, gpointer data);
void i_callback_page_next(GtkWidget *widget, gpointer data);
void i_callback_page_prev(GtkWidget *widget, gpointer data);
void i_callback_page_new(GtkWidget *widget, gpointer data);
void i_callback_page_close(GtkWidget *widget, gpointer data);
void i_callback_page_discard(GtkWidget *widget, gpointer data);
void i_callback_page_print(GtkWidget *widget, gpointer data);
void i_callback_add_component(GtkWidget *widget, gpointer data);
void i_callback_add_attribute(GtkWidget *widget, gpointer data);
void i_callback_route_net(GtkWidget *widget, gpointer data);
void i_callback_add_net(GtkWidget *widget, gpointer data);
void i_callback_add_net_hotkey(GtkWidget *widget, gpointer data);
void i_callback_add_text(GtkWidget *widget, gpointer data);
void i_callback_add_line(GtkWidget *widget, gpointer data);
void i_callback_add_line_hotkey(GtkWidget *widget, gpointer data);
void i_callback_add_box(GtkWidget *widget, gpointer data);
void i_callback_add_box_hotkey(GtkWidget *widget, gpointer data);
void i_callback_add_circle(GtkWidget *widget, gpointer data);
void i_callback_add_circle_hotkey(GtkWidget *widget, gpointer data);
void i_callback_add_arc(GtkWidget *widget, gpointer data);
void i_callback_add_arc_hotkey(GtkWidget *widget, gpointer data);
void i_callback_hierarchy_open_symbol(GtkWidget *widget, gpointer data);
void i_callback_attributes_attach(GtkWidget *widget, gpointer data);
void i_callback_attributes_detach(GtkWidget *widget, gpointer data);
void i_callback_attributes_show_name(GtkWidget *widget, gpointer data);
void i_callback_attributes_show_value(GtkWidget *widget, gpointer data);
void i_callback_attributes_show_both(GtkWidget *widget, gpointer data);
void i_callback_attributes_visibility_toggle(GtkWidget *widget, gpointer data);
void i_callback_script_console(GtkWidget *widget, gpointer data);
void i_callback_options_text_size(GtkWidget *widget, gpointer data);
void i_callback_options_snap_size(GtkWidget *widget, gpointer data);
void i_callback_options_afeedback(GtkWidget *widget, gpointer data);
void i_callback_options_grid(GtkWidget *widget, gpointer data);
void i_callback_options_snap(GtkWidget *widget, gpointer data);
void i_callback_options_show_status(GtkWidget *widget, gpointer data);
void i_callback_misc(GtkWidget *widget, gpointer data);
void i_callback_cancel(GtkWidget *widget, gpointer data);
/* i_sbox.c */
void i_sbox_search(TOPLEVEL *w_current, int flag);
void i_sbox_start(TOPLEVEL *w_current, int x, int y);
void i_sbox_end(TOPLEVEL *w_current, int x, int y);
void i_sbox_rubberbox(TOPLEVEL *w_current, int x, int y);
/* i_vars.c */
void i_vars_setdefault(TOPLEVEL *w_current);
/* list.c */
FOOTPRINT_T *footprint_defined(PAGE_T *page, FOOTPRINT_ID id);
void component_add(PAGE_T *page, FOOTPRINT_T *foot, char *id, int x, int y);
void o_component_add(PAGE_T *page, char *id, int x, int y);
void o_selections_free(PAGE_T *page);
void o_selection_add(PAGE_T *page, SELECTION_T *selection);
FOOTPRINT_T *footprint_add(PAGE_T *page, char *footDef);
void o_footprint_add(PAGE_T *page, OBJECT *object, int x, int y);
void net_add(PAGE_T *page, NET_T *net);
void pad_add(FOOTPRINT_T *foot, char *padDef);
void track_add(PAGE_T *page, TRACK_T *newTrack);
void o_pad_add(PAGE_T *page, OBJECT *object, int x, int y);
/* net.c */
void o_net_rubberband(TOPLEVEL *w_current, NET_T *net, int mouse_x, int mouse_y);
void net_draw(TOPLEVEL *w_current, NET_T *net, drawing_type modifier);
void printNet(NET_T *net);
/* o_arc.c */
void o_arc_draw(TOPLEVEL *w_current, OBJECT *o_current);
void o_arc_draw_xor(TOPLEVEL *w_current, int dx, int dy, OBJECT *o_current);
void o_arc_start(TOPLEVEL *w_current, int x, int y);
void o_arc_end1(TOPLEVEL *w_current, int x, int y);
void o_arc_end2(TOPLEVEL *w_current, int start_angle, int end_angle);
void o_arc_rubberline(TOPLEVEL *w_current, int x, int y);
/* o_attrib.c */
void deal_attr(TOPLEVEL *w_current, OBJECT *selected);
void o_attrib_toggle_visibility(TOPLEVEL *w_current, OBJECT *list);
void o_attrib_toggle_show_name_value(TOPLEVEL *w_current, OBJECT *list, int new_show_name_value);
void o_attrib_start(TOPLEVEL *w_current, int screen_x, int screen_y);
void o_attrib_end(TOPLEVEL *w_current);
void o_attrib_rubberattrib(TOPLEVEL *w_current);
/* o_basic.c */
void o_redraw_all(TOPLEVEL *w_current);
void o_redraw(TOPLEVEL *w_current, OBJECT *object_list);
void o_unselect_all(TOPLEVEL *w_current);
void updateNetCoords(NET_T *net);
int insideComponent(COMPONENT_T *comp, int x, int y);
int onNet(NET_T *net, int x, int y);
int insidePad(PAD_T *pad, int x, int y);
void o_find(TOPLEVEL *w_current, int x, int y);
int endNet(TOPLEVEL *w_current, NET_T *net, TRACK_SEG_T *seg, int x, int y);
NET_T *find_net(TOPLEVEL *w_current, int x, int y);
COMPONENT_T *find_component(TOPLEVEL *w_current, int x, int y);
PAD_T *find_pad(TOPLEVEL *w_current, COMPONENT_T *comp, int x, int y);
OBJECT *o_find_pad(TOPLEVEL *w_current, int x, int y);
void o_select(TOPLEVEL *w_current, OBJECT *selected);
void o_select_many(TOPLEVEL *w_current, OBJECT *selected, int count);
void o_redraw_selected(TOPLEVEL *w_current);
void o_unredraw_selected(TOPLEVEL *w_current);
void o_erase_selected(TOPLEVEL *w_current);
void o_erase_single(TOPLEVEL *w_current, OBJECT *object);
void o_unredraw_real(TOPLEVEL *w_current, OBJECT *list);
void o_nets_translate(TOPLEVEL *w_current, int diff_x, int diff_y, OBJECT *o_current);
void o_drawbounding(TOPLEVEL *w_current, OBJECT *o_current, GdkColor *color);
void o_erasebounding(TOPLEVEL *w_current, OBJECT *o_current);
/* o_box.c */
void o_box_draw(TOPLEVEL *w_current, OBJECT *o_current);
void o_box_draw_xor(TOPLEVEL *w_current, int dx, int dy, OBJECT *o_current);
void o_box_start(TOPLEVEL *w_current, int x, int y);
void o_box_end(TOPLEVEL *w_current, int x, int y);
void o_box_rubberbox(TOPLEVEL *w_current, int x, int y);
/* o_circle.c */
void o_circle_draw(TOPLEVEL *w_current, OBJECT *o_current);
void o_circle_draw_xor(TOPLEVEL *w_current, int dx, int dy, OBJECT *o_current);
void o_circle_start(TOPLEVEL *w_current, int x, int y);
void o_circle_end(TOPLEVEL *w_current, int x, int y);
void o_circle_rubbercircle(TOPLEVEL *w_current, int x, int y);
/* o_complex.c */
void o_complex_draw(TOPLEVEL *w_current, OBJECT *o_current);
void o_complex_draw_xor(TOPLEVEL *w_current, int dx, int dy, OBJECT *complex);
void o_complex_start(TOPLEVEL *w_current, int screen_x, int screen_y);
void o_complex_end(TOPLEVEL *w_current, int screen_x, int screen_y);
void o_complex_rubbercomplex(TOPLEVEL *w_current);
void o_complex_translate_display(TOPLEVEL *w_current, int x1, int y1, OBJECT *complex);
void o_complex_translate_all(TOPLEVEL *w_current, int offset);
void o_complex_translate2(TOPLEVEL *w_current, int dx, int dy, OBJECT *object);
void o_complex_rotate(TOPLEVEL *w_current, int centerx, int centery, int angle, int angle_change, OBJECT *object);
int o_complex_mirror(TOPLEVEL *w_current, int centerx, int centery, OBJECT *object);
OBJECT *o_complex_mirror2(TOPLEVEL *w_current, OBJECT *list, int centerx, int centery, OBJECT *object);
/* o_conn.c */
void o_conn_draw_endpoint(TOPLEVEL *w_current, GdkGC *local_gc, int x, int y);
void o_conn_draw_midpoint(TOPLEVEL *w_current, GdkGC *local_gc, int x, int y);
void o_conn_draw(TOPLEVEL *w_current, OBJECT *head);
/* o_copy.c */
void o_copy_start(TOPLEVEL *w_current, int x, int y);
void o_copy_end(TOPLEVEL *w_current);
/* o_delete.c */
void o_delete(TOPLEVEL *w_current);
/* o_line.c */
void o_line_draw(TOPLEVEL *w_current, OBJECT *o_current);
void o_line_draw_xor(TOPLEVEL *w_current, int dx, int dy, OBJECT *o_current);
void o_line_start(TOPLEVEL *w_current, int x, int y);
void o_line_end(TOPLEVEL *w_current, int x, int y);
void o_line_rubberline(TOPLEVEL *w_current, int x, int y);
/* o_misc.c */
void o_edit(TOPLEVEL *w_current, OBJECT *list);
void o_lock(TOPLEVEL *w_current);
void o_unlock(TOPLEVEL *w_current);
void o_rotate_90(TOPLEVEL *w_current, OBJECT *list, int centerx, int centery);
void o_embed(TOPLEVEL *w_current);
void o_unembed(TOPLEVEL *w_current);
void o_mirror(TOPLEVEL *w_current, OBJECT *list, int centerx, int centery);
/* o_move.c */
void o_move_start(TOPLEVEL *w_current, int x, int y);
void o_move_end(TOPLEVEL *w_current);
/* o_net.c */
void o_net_conn_erase(TOPLEVEL *w_current, OBJECT *o_current, int whichone);
void o_net_conn_recalc_draw(TOPLEVEL *w_current, OBJECT *object_list);
void o_net_draw(TOPLEVEL *w_current, OBJECT *o_current);
void o_net_draw_xor(TOPLEVEL *w_current, int dx, int dy, OBJECT *o_current);
void o_net_start(TOPLEVEL *w_current, int x, int y);
void o_net_end(TOPLEVEL *w_current, int x, int y);
void o_net_rubbernet(TOPLEVEL *w_current, int x, int y);
void o_net_eraserubber(TOPLEVEL *w_current);
/* o_ntext.c */
void o_ntext_draw(TOPLEVEL *w_current, OBJECT *o_current);
void o_ntext_draw_xor(TOPLEVEL *w_current, int dx, int dy, OBJECT *o_current);
void o_ntext_input(TOPLEVEL *w_current);
void o_ntext_start(TOPLEVEL *w_current, int screen_x, int screen_y);
void o_ntext_end(TOPLEVEL *w_current);
void o_ntext_rubberattrib(TOPLEVEL *w_current);
void o_ntext_edit(TOPLEVEL *w_current, OBJECT *o_current);
void o_ntext_edit_end(TOPLEVEL *w_current, char *string, int len);
/* o_route.c */
void o_route_draw(TOPLEVEL *w_current, OBJECT *o_current);
void o_route_draw_xor(TOPLEVEL *w_current, int dx, int dy, OBJECT *o_current);
void o_route_start(TOPLEVEL *w_current, int x, int y);
void o_route_end(TOPLEVEL *w_current, int x, int y);
void o_route_rubberline(TOPLEVEL *w_current, int x, int y);
/* o_slot.c */
void o_slot_start(TOPLEVEL *w_current, OBJECT *list);
void o_slot_end(TOPLEVEL *w_current, char *string, int len);
/* o_thru_hole.c */
void o_thru_hole_draw(TOPLEVEL *w_current, OBJECT *o_current);
void o_thru_hole_draw_xor(TOPLEVEL *w_current, int dx, int dy, OBJECT *o_current);
void o_thru_hole_start(TOPLEVEL *w_current, int x, int y);
void o_thru_hole_end(TOPLEVEL *w_current, int x, int y);
void o_thru_hole_rubbercircle(TOPLEVEL *w_current, int x, int y);
/* pad.c */
void o_pad_draw(TOPLEVEL *w_current, PAD_T *pad, int x, int y, drawing_type modifier);
/* parsecmd.c */
void usage(char *cmd);
int parse_commandline(int argc, char *argv[]);
/* track.c */
void squareRoute(int src_x, int src_y, int *dst_x, int *dst_y);
void endRoute(TOPLEVEL *w_current, int x, int y);
void continueRoute(TOPLEVEL *w_current, int x, int y);
void route_start(TOPLEVEL *w_current, NET_T *net, int x, int y);
void route_rubberband(TOPLEVEL *w_current, int mouse_x, int mouse_y);
void seg_draw(TOPLEVEL *w_current, TRACK_SEG_T *seg, drawing_type modifier);
void printSegment(TRACK_SEG_T *seg);
void printTrack(TRACK_T *track);
/* x_attrsel.c */
gint change_attr(GtkWidget *gtklist, TOPLEVEL *w_current);
gint attr_set_show_name(GtkWidget *w, TOPLEVEL *w_current);
gint attr_set_show_value(GtkWidget *w, TOPLEVEL *w_current);
gint attr_set_show_both(GtkWidget *w, TOPLEVEL *w_current);
gint attr_set_visible(GtkWidget *w, TOPLEVEL *w_current);
gint attr_set_invisible(GtkWidget *w, TOPLEVEL *w_current);
gint attr_apply(GtkWidget *w, TOPLEVEL *w_current);
gint attr_cancel(GtkWidget *w, TOPLEVEL *w_current);
void setup_attr_selector(TOPLEVEL *w_current);
/* x_basic.c */
GdkColor *x_get_color(int color);
GdkColor *x_get_darkcolor(int color);
void x_repaint_background(TOPLEVEL *w_current);
void x_hscrollbar_set_ranges(TOPLEVEL *w_current);
void x_hscrollbar_update(TOPLEVEL *w_current);
void x_vscrollbar_set_ranges(TOPLEVEL *w_current);
void x_vscrollbar_update(TOPLEVEL *w_current);
void x_scrollbars_update(TOPLEVEL *w_current);
/* x_compsel.c */
gint embed_components(GtkWidget *w, TOPLEVEL *w_current);
gint change_clib(GtkWidget *gtklist, TOPLEVEL *w_current);
gint change_basename(GtkWidget *gtklist, TOPLEVEL *w_current);
void setup_place_file_selector(TOPLEVEL *w_current);
/* x_dialog.c */
void text_input_dialog_apply(GtkWidget *w, TOPLEVEL *w_current);
void text_input_dialog_close(GtkWidget *w, TOPLEVEL *w_current);
void text_input_dialog(TOPLEVEL *w_current);
void text_edit_dialog_ok(GtkWidget *w, TOPLEVEL *w_current);
void text_edit_dialog_cancel(GtkWidget *w, TOPLEVEL *w_current);
void text_edit_dialog(TOPLEVEL *w_current, char *string);
void exit_dialog_ok(GtkWidget *w, TOPLEVEL *w_current);
void exit_dialog_cancel(GtkWidget *w, TOPLEVEL *w_current);
void exit_dialog(TOPLEVEL *w_current);
void arc_angles_dialog_ok(GtkWidget *w, TOPLEVEL *w_current);
void arc_angles_dialog_cancel(GtkWidget *w, TOPLEVEL *w_current);
void arc_angle_dialog(TOPLEVEL *w_current);
void translate_dialog_ok(GtkWidget *w, TOPLEVEL *w_current);
void translate_dialog_cancel(GtkWidget *w, TOPLEVEL *w_current);
void translate_dialog(TOPLEVEL *w_current);
void text_size_dialog_ok(GtkWidget *w, TOPLEVEL *w_current);
void text_size_dialog_cancel(GtkWidget *w, TOPLEVEL *w_current);
void text_size_dialog(TOPLEVEL *w_current);
void snap_size_dialog_ok(GtkWidget *w, TOPLEVEL *w_current);
void snap_size_dialog_cancel(GtkWidget *w, TOPLEVEL *w_current);
void snap_size_dialog(TOPLEVEL *w_current);
void slot_edit_dialog_ok(GtkWidget *w, TOPLEVEL *w_current);
void slot_edit_dialog_cancel(GtkWidget *w, TOPLEVEL *w_current);
void slot_edit_dialog(TOPLEVEL *w_current, char *string);
/* x_event.c */
gint x_event_expose(GtkWidget *widget, GdkEventExpose *event, TOPLEVEL *w_current);
gint x_event_button_pressed(GtkWidget *widget, GdkEventButton *event, TOPLEVEL *w_current);
gint x_event_button_released(GtkWidget *widget, GdkEventButton *event, TOPLEVEL *w_current);
gint x_event_motion(GtkWidget *widget, GdkEventMotion *event, TOPLEVEL *w_current);
gint x_event_configure(GtkWidget *widget, GdkEventConfigure *event, TOPLEVEL *w_current);
void x_manual_resize(TOPLEVEL *w_current);
void x_event_hschanged(GtkAdjustment *adj, TOPLEVEL *w_current);
void x_event_vschanged(GtkAdjustment *adj, TOPLEVEL *w_current);
gint x_event_enter(GtkWidget *widget, GdkEventCrossing *event, TOPLEVEL *w_current);
gint x_event_key_press(GtkWidget *widget, GdkEventKey *event, TOPLEVEL *w_current);
/* x_filesel.c */
void destroy_window(GtkWidget *widget, GtkWidget **window);
void file_selection_ok_open(GtkWidget *w, TOPLEVEL *w_current);
void file_selection_cancel_open(GtkWidget *w, TOPLEVEL *w_current);
void setup_open_file_selector(TOPLEVEL *w_current);
void file_selection_ok_saveas(GtkWidget *w, TOPLEVEL *w_current);
void file_selection_cancel_saveas(GtkWidget *w, TOPLEVEL *w_current);
void setup_saveas_file_selector(TOPLEVEL *w_current, int flag, char *filename);
/* x_grid.c */
void x_grid_draw(TOPLEVEL *w_current);
/* x_log.c */
void x_log_read(void);
void x_log_update(char *buf);
void x_log_close(GtkWidget *w, TOPLEVEL *w_current);
void x_log_setup_win(TOPLEVEL *w_current);
/* x_menus.c */
void get_main_menu(TOPLEVEL *w_current, GtkWidget **menubar, GtkAcceleratorTable **table);
void get_main_popup(TOPLEVEL *w_current, GtkWidget **menu, GtkAcceleratorTable **table);
void menus_init(TOPLEVEL *w_current);
void menus_create(TOPLEVEL *w_current, GtkMenuEntry *entries, int nmenu_entries);
gint do_popup(TOPLEVEL *w_current, GdkEventButton *event);
/* x_pagesel.c */
void update_page_manager(GtkWidget *widget, TOPLEVEL *w_current);
gint save_page(GtkWidget *gtklist, TOPLEVEL *w_current);
gint change_page(GtkWidget *widget, gint row, gint column, GdkEventButton *bevent);
void setup_page_selector(TOPLEVEL *w_current);
/* x_print.c */
gint x_print_change_size(GtkWidget *gtklist, TOPLEVEL *w_current);
gint x_print_set_window(GtkWidget *w, TOPLEVEL *w_current);
gint x_print_set_limits(GtkWidget *w, TOPLEVEL *w_current);
gint x_print_print(GtkWidget *w, TOPLEVEL *w_current);
gint x_print_cancel(GtkWidget *w, TOPLEVEL *w_current);
void x_print_setup(TOPLEVEL *w_current, char *filename);
/* x_window.c */
TOPLEVEL *x_window_add(TOPLEVEL *w_head, TOPLEVEL *w_current);
void x_window_add_head(void);
void x_window_free_head(void);
void x_window_delete(TOPLEVEL *w_head, TOPLEVEL *w_current);
void x_window_setup_world(TOPLEVEL *w_current);
void x_window_setup_rest(TOPLEVEL *w_current);
void x_window_setup_colors(void);
void x_window_free_colors(TOPLEVEL *w_current);
void x_window_setup_gc(TOPLEVEL *w_current);
void x_window_free_gc(TOPLEVEL *w_current);
void x_window_create_drawing(GtkWidget *drawbox, TOPLEVEL *w_current);
void x_window_setup_draw_events(TOPLEVEL *w_current);
void x_window_create_main(TOPLEVEL *w_current);
TOPLEVEL *x_window_create_new(void);
void x_window_close(TOPLEVEL *w_current);
void x_window_close_all(void);
TOPLEVEL *x_window_get_ptr(int wid);
TOPLEVEL *x_window_search_page_clist(GtkWidget *findme);
