/* gEDA - GNU Electronic Design Automation
 * gpcb - GNU Printed Circuit Board
 * Copyright (C) 1998 Ales V. Hvezda
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef TRACK_H
#define TRACK_H

#include <config.h>
#include <math.h>
#include <stdio.h>

#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk/gdkx.h>

#include <guile/gh.h>

#include "struct.h"
#include "defines.h"
#include "globals.h"
#include "s_passing.h"
#include "o_types.h"

#include "colors.h"

#include "pcb_struct.h"
#include "a_memory.h"

#include "prototype.h"
#include "../libgeda/prototype.h"

void
squareRoute(int src_x, int src_y, int *dst_x, int *dst_y);

void
endRoute(TOPLEVEL *w_current, int x, int y);

void
continueRoute(TOPLEVEL *w_current, int x, int y);

void
route_start(TOPLEVEL *w_current, NET_T *net, int x, int y);

void
route_rubberband(TOPLEVEL *w_current, int mouse_x, int mouse_y);

void
seg_draw(TOPLEVEL *w_current, TRACK_SEG_T *seg, drawing_type modifier);

void
printSegment(TRACK_SEG_T *seg);

void
printTrack(TRACK_T *track);

#endif
